﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        WinformsMap1.MapUnit = ThinkGeo.MapSuite.Core.GeographyUnit.DecimalDegree

        'InMemoryFeatureLayer to hold your features (in this case we add only one feature)
        Dim fishLayer As InMemoryFeatureLayer = New InMemoryFeatureLayer()
        'Adds the "Angle" column to the InMemoryFeatureLayer
        fishLayer.Open()
        fishLayer.Columns.Add(New FeatureSourceColumn("Angle"))
        fishLayer.Columns.Add(New FeatureSourceColumn("Color"))
        fishLayer.Close()

        'fishLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.PointType = PointType.Bitmap
        'fishLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.Image = New GeoImage("..\..\data\icon.png")
        'fishLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.RotationAngle = 0
        Dim rotatedImageStyle As New RotatedImageStyle(New GeoImage("..\..\data\blue_icon.png"), New GeoImage("..\..\data\red_icon.png"), "Color", "Angle")
        fishLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Clear()
        fishLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(rotatedImageStyle)
        fishLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

        'Creates two features made of a PointShape
        'Note that a Feature can be made of any type of shape, PolygonShape, LineShape etc.
        Dim feature As New Feature(New PointShape(-98, 38))
        'Sets
        feature.ColumnValues("Angle") = "0"
        feature.ColumnValues("Color") = "Blue"
        'Adds the feature to the InMemoryFeatureLayer with Id "Fish1"
        fishLayer.InternalFeatures.Add("Fish1", feature)

        Dim feature2 As New Feature(New PointShape(-99, 43))
        feature2.ColumnValues("Angle") = "305"
        feature2.ColumnValues("Color") = "Blue"
        'Adds the feature to the InMemoryFeatureLayer with Id "Fish2"
        fishLayer.InternalFeatures.Add("Fish2", feature2)

        'Creates a LayerOverlay for the InMemoryFeatureLayers (in this case only one InMemoryFeatureLayer)
        Dim layerOverlay As LayerOverlay = New LayerOverlay()

        'Adds the InMemoryFeatureLayer with id "FishLayer".
        layerOverlay.Layers.Add("FishLayer", fishLayer)

        'Adds the LayerOvelay to the Overlays collection of the map with id "LayerOverlay"
        WinformsMap1.Overlays.Add("LayerOverlay", layerOverlay)

        WinformsMap1.CurrentExtent = New RectangleShape(-100, 45, -90, 35)
        WinformsMap1.Refresh()

    End Sub

    Private Sub btnRotateIcon_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRotateIcon.Click

        Dim layerOverlay As LayerOverlay = DirectCast(WinformsMap1.Overlays("LayerOverlay"), LayerOverlay)
        Dim fishLayer As InMemoryFeatureLayer = DirectCast(layerOverlay.Layers("FishLayer"), InMemoryFeatureLayer)

        'Gets the feature of Id "Fish1" and change the column value "Angle"
        Dim feature As Feature = fishLayer.InternalFeatures("Fish1")
        feature.ColumnValues("Angle") = "135"
        feature.ColumnValues("Color") = "Red"

        'Refreshes only the LayerOverlay we did a change to so that we don't have to refresh the entire map.
        WinformsMap1.Refresh(layerOverlay)
    End Sub

    Private Sub btnMove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMove.Click

        Dim layerOverlay As LayerOverlay = DirectCast(WinformsMap1.Overlays("LayerOverlay"), LayerOverlay)
        Dim fishLayer As InMemoryFeatureLayer = DirectCast(layerOverlay.Layers("FishLayer"), InMemoryFeatureLayer)

        Dim feature As Feature = fishLayer.InternalFeatures("Fish1")
        Dim pointShape As PointShape = DirectCast(feature.GetShape(), PointShape)

        pointShape.X = -96
        pointShape.Y = 42
        'Sets the id of the PointShape so that the PointShape of the Feature "Fish1" is updated
        pointShape.Id = "Fish1"

        'Updates the InMemoryFeatureLayer
        fishLayer.Open()
        fishLayer.EditTools.BeginTransaction()
        fishLayer.EditTools.Update(pointShape)
        fishLayer.EditTools.CommitTransaction()
        fishLayer.Close()

        'Refreshes only the LayerOverlay we did a change to so that we don't have to refresh the entire map.
        WinformsMap1.Refresh(layerOverlay)
    End Sub

   
End Class
