﻿Imports System
Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite.Core

Class RotatedImageStyle
    Inherits Style
    Private blue_GeoImage As GeoImage
    Private red_GeoImage As GeoImage
    Private angleColumnName As String
    Private colorColumnName As String

    Public Sub New()
        Me.New(New GeoImage(), New GeoImage(), String.Empty, String.Empty)
    End Sub

    Public Sub New(ByVal blue_GeoImage As GeoImage, ByVal red_GeoImage As GeoImage, ByVal colorColumnName As String, ByVal angleColumnName As String)
        Me.blue_GeoImage = blue_GeoImage
        Me.red_GeoImage = red_GeoImage
        Me.colorColumnName = colorColumnName
        Me.angleColumnName = angleColumnName
    End Sub

    Protected Overrides Sub DrawCore(ByVal features As System.Collections.Generic.IEnumerable(Of ThinkGeo.MapSuite.Core.Feature), _
                                    ByVal canvas As GeoCanvas, ByVal labelsInThisLayer As Collection(Of ThinkGeo.MapSuite.Core.SimpleCandidate), _
                                    ByVal labelsInAllLayers As Collection(Of SimpleCandidate))

        For Each feature As Feature In features
            Dim angleData As Single = Convert.ToSingle(feature.ColumnValues(angleColumnName))
            Dim pointShape As PointShape = DirectCast(feature.GetShape(), PointShape)
            'angleData);
            If feature.ColumnValues(colorColumnName) = "Blue" Then
                canvas.DrawWorldImageWithoutScaling(blue_GeoImage, pointShape.X, pointShape.Y, DrawingLevel.LevelFour, 0, 0, _
                 360 - angleData)
            Else
                canvas.DrawWorldImageWithoutScaling(red_GeoImage, pointShape.X, pointShape.Y, DrawingLevel.LevelFour, 0, 0, _
                360 - angleData)
            End If
        Next
    End Sub

    Protected Overrides Function GetRequiredColumnNamesCore() As Collection(Of String)
        Dim columns As New Collection(Of String)
        If Not columns.Contains(angleColumnName) Then
            columns.Add(angleColumnName)
        End If
        If Not columns.Contains(colorColumnName) Then
            columns.Add(colorColumnName)
        End If
        Return columns
    End Function
End Class

